using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ITypedListDataSourceSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(264, 208);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ResizingColumns += new Syncfusion.Windows.Forms.Grid.GridResizingColumnsEventHandler(this.gridDataBoundGrid1_ResizingColumns);
			this.gridDataBoundGrid1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.gridDataBoundGrid1_MouseUp);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(56, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(160, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "New Random Data";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region Set the DataSource
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = dt;
			#endregion
		}

		private Random r = new Random();
		private void button1_Click(object sender, System.EventArgs e)
		{
			
			int nCols = r.Next(10) + 1;
			int nRows = r.Next(50);

			//create a arbitrary list of types for the columns
			Type[] types = new Type[nCols];
			string[] names = new string[nCols];
			for(int col = 0; col < nCols; ++col)
			{
				switch (r.Next(4))
				{
					case 0: 
						types[col] = typeof(DateTime);
						names[col] = "date_" + col.ToString();
						break;
					case 1:
						types[col] = typeof(int);
						names[col] = "int_" + col.ToString();
						break;
					case 2:
						types[col] = typeof(double);
						names[col] = "double_" + col.ToString();
						break;
					default:
						types[col] = typeof(string);
						names[col] = "string_" + col.ToString();
						break;
				}
			}

			DataSourceArrayList arrayList = new DataSourceArrayList(types, names);

			for(int row = 0; row < nRows; ++row)
			{
				
				MyObject obj = new MyObject(nCols);
				arrayList.Add(obj);

				for(int col = 0; col < nCols; ++col)
				{
					object val = null;

					if(types[col] == typeof(DateTime))
					{
						val = DateTime.Now;
					}
					else if(types[col] == typeof(int))
					{
						val = r.Next(1000);
					}
					else if(types[col] == typeof(double))
					{
						val = r.NextDouble() * 100;
					}
					else if(types[col] == typeof(string))
					{
						val = "string" + (col * 1000 + row).ToString();
					}

					PropertyDescriptor pd = arrayList.pdc[col];
					pd.SetValue(obj, val);
				}
			}

			this.gridDataBoundGrid1.BeginUpdate();

			this.gridDataBoundGrid1.DataSource = null;
			this.gridDataBoundGrid1.DataSource = arrayList;
		

			this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(this.gridDataBoundGrid1.ViewLayout.VisibleCellsRange, GridResizeToFitOptions.IncludeHeaders);
			this.gridDataBoundGrid1.EndUpdate();

			this.gridDataBoundGrid1.Refresh();
		}

		private bool resized = false;
		private void gridDataBoundGrid1_ResizingColumns(object sender, Syncfusion.Windows.Forms.Grid.GridResizingColumnsEventArgs e)
		{
			if(e.Reason == GridResizeCellsReason.MouseDown)
				this.resized = true;
		}

		private void gridDataBoundGrid1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(this.resized)
			{
				this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());
				this.resized = false;
			}
		}
	}
}
